Package com.google.javascript.rhino.jstype

# Class UnknownType

java.lang.Object
com.google.javascript.rhino.jstype.JSType
com.google.javascript.rhino.jstype.ObjectType
com.google.javascript.rhino.jstype.UnknownType

All Implemented Interfaces:
  `StaticScope<JSType>`, `Serializable`

public class UnknownType extends ObjectType
The `Unknown` type.

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class com.google.javascript.rhino.jstype.JSType

`JSType.TypePair`

## Field Summary

### Fields inherited from class com.google.javascript.rhino.jstype.JSType

`EMPTY_TYPE_COMPONENT, ENUMDECL, NOT_A_CLASS, NOT_A_TYPE, NOT_ENUMDECL, templateTypeMap, UNKNOWN_NAME`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`canBeCalled()`
This predicate is used to test whether a given type can be used as the 'function' in a function call.
`FunctionType`
`getConstructor()`
Gets this object's constructor.
`String`
`getDisplayName()`
Returns a user meaningful label for the JSType instance.
`ObjectType`
`getImplicitPrototype()`
Gets the implicit prototype (a.k.a.
`BooleanLiteralSet`
`getPossibleToBooleanOutcomes()`
Computes the set of possible outcomes of the `ToBoolean` predicate for this type.
`String`
`getReferenceName()`
Gets the reference name for this object.
`boolean`
`hasDisplayName()`
`boolean`
`isCheckedUnknownType()`
`boolean`
`isNullable()`
Tests whether this type is nullable.
`boolean`
`isSubtype(JSType that)`
Checks whether `this` is a subtype of `that`.
`boolean`
`isUnknownType()`
We treat this as the unknown type if any of its implicit prototype properties is unknown.
`boolean`
`matchesNumberContext()`
This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.
`boolean`
`matchesObjectContext()`
This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement.
`boolean`
`matchesStringContext()`
This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator.
`TernaryValue`
`testForEquality(JSType that)`
Compares `this` and `that`.
`<T> T`
`visit(Visitor<T> visitor)`
Visit this type with the given visitor.

### Methods inherited from class com.google.javascript.rhino.jstype.ObjectType

`cast, clearCachedValues, createDelegateSuffix, defineDeclaredProperty, defineInferredProperty, defineSynthesizedProperty, findPropertyType, getCtorExtendedInterfaces, getCtorImplementedInterfaces, getJSDocInfo, getNormalizedReferenceName, getOwnerFunction, getOwnPropertyJSDocInfo, getOwnPropertyNames, getOwnSlot, getParentScope, getPropertiesCount, getPropertyNames, getPropertyNode, getPropertyType, getRootNode, getSlot, getTemplateTypes, getTypeOfThis, hasCachedValues, hasOwnProperty, hasProperty, hasReferenceName, isFunctionPrototypeType, isNativeObjectType, isObject, isPropertyInExterns, isPropertyTypeDeclared, isPropertyTypeInferred, removeProperty, setJSDocInfo, setPropertyJSDocInfo`

### Methods inherited from class com.google.javascript.rhino.jstype.JSType

`autobox, autoboxesTo, canCastTo, canTestForEqualityWith, canTestForShallowEqualityWith, clearResolved, collapseUnion, dereference, differsFrom, equals, forceResolve, getGreatestSubtype, getLeastSupertype, getRestrictedTypeGivenToBooleanOutcome, getTemplateTypeMap, getTypesUnderEquality, getTypesUnderInequality, getTypesUnderShallowEquality, getTypesUnderShallowInequality, hasAnyTemplateTypes, hashCode, isAllType, isArrayType, isBooleanObjectType, isBooleanValueType, isConstructor, isDateType, isDict, isEmptyType, isEnumElementType, isEnumType, isEquivalent, isEquivalentTo, isFunctionType, isGlobalThisType, isInstanceType, isInterface, isInvariant, isNominalConstructor, isNominalType, isNoObjectType, isNoResolvedType, isNoType, isNullType, isNumber, isNumberObjectType, isNumberValueType, isOrdinaryFunction, isRecordType, isRegexpType, isResolved, isString, isStringObjectType, isStringValueType, isStruct, isTemplateType, isTemplatizedType, isUnionType, isVoidType, matchConstraint, matchesInt32Context, matchesUint32Context, resolve, restrictByNotNullOrUndefined, setValidator, toAnnotationString, toDebugHashCodeString, toMaybeEnumElementType, toMaybeEnumType, toMaybeFunctionType, toMaybeFunctionType, toMaybeTemplateType, toMaybeTemplateType, toMaybeTemplatizedType, toMaybeTemplatizedType, toMaybeUnionType, toObjectType, toString, unboxesTo`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Method Details

### isUnknownType

public boolean isUnknownType()
Description copied from class: `ObjectType`
We treat this as the unknown type if any of its implicit prototype properties is unknown.

Overrides:
  `isUnknownType` in class `ObjectType`

### isCheckedUnknownType

public boolean isCheckedUnknownType()

Overrides:
  `isCheckedUnknownType` in class `JSType`

### canBeCalled

public boolean canBeCalled()
Description copied from class: `JSType`
This predicate is used to test whether a given type can be used as the 'function' in a function call.

Overrides:
  `canBeCalled` in class `JSType`
Returns:
  `true` if this type might be callable.

### matchesNumberContext

public boolean matchesNumberContext()
Description copied from class: `JSType`
This predicate is used to test whether a given type can appear in a numeric context, such as an operand of a multiply operator.

Overrides:
  `matchesNumberContext` in class `JSType`

### matchesObjectContext

public boolean matchesObjectContext()
Description copied from class: `JSType`
This predicate is used to test whether a given type can appear in an `Object` context, such as the expression in a with statement. Most types we will encounter, except notably `null`, have at least the potential for converting to `Object`. Host defined objects can get peculiar.

Overrides:
  `matchesObjectContext` in class `JSType`

### matchesStringContext

public boolean matchesStringContext()
Description copied from class: `JSType`
This predicate is used to test whether a given type can appear in a `String` context, such as an operand of a string concat (+) operator. All types have at least the potential for converting to `String`. When we add externally defined types, such as a browser OM, we may choose to add types that do not automatically convert to `String`.

Overrides:
  `matchesStringContext` in class `JSType`

### testForEquality

public TernaryValue testForEquality(JSType that)
Description copied from class: `JSType`
Compares `this` and `that`.

Overrides:
  `testForEquality` in class `ObjectType`
Returns:
  - `TernaryValue.TRUE` if the comparison of values of `this` type and `that` always succeed (such as `undefined` compared to `null`)
  - `TernaryValue.FALSE` if the comparison of values of `this` type and `that` always fails (such as `undefined` compared to `number`)
  - `TernaryValue.UNKNOWN` if the comparison can succeed or fail depending on the concrete values

### isNullable

public boolean isNullable()
Description copied from class: `JSType`
Tests whether this type is nullable.

Overrides:
  `isNullable` in class `JSType`

### isSubtype

public boolean isSubtype(JSType that)
Description copied from class: `JSType`
Checks whether `this` is a subtype of `that`.

Subtyping rules:

- (unknown) — every type is a subtype of the Unknown type.
- (no) — the No type is a subtype of every type.
- (no-object) — the NoObject type is a subtype of every object type (i.e. subtypes of the Object type).
- (ref) — a type is a subtype of itself.
- (union-l) — A union type is a subtype of a type U if all the union type's constituents are a subtype of U. Formally
  `(T<sub>1</sub>, &hellip;, T<sub>n</sub>) &lt;: U` if and only `T<sub>k</sub> &lt;: U` for all `k &isin; 1..n`.
- (union-r) — A type U is a subtype of a union type if it is a subtype of one of the union type's constituents. Formally
  `U &lt;: (T<sub>1</sub>, &hellip;, T<sub>n</sub>)` if and only if `U &lt;: T<sub>k</sub>` for some index `k`.
- (objects) — an Object `O<sub>1</sub>` is a subtype of an object `O<sub>2</sub>` if it has more properties than `O<sub>2</sub>` and all common properties are pairwise subtypes.

Overrides:
  `isSubtype` in class `JSType`
Returns:
  `this &lt;: that`

### visit

public <T> T visit(Visitor<T> visitor)
Description copied from class: `JSType`
Visit this type with the given visitor.

Overrides:
  `visit` in class `ObjectType`
Returns:
  the value returned by the visitor
See Also:
  - `Visitor`

### getImplicitPrototype

public ObjectType getImplicitPrototype()
Description copied from class: `ObjectType`
Gets the implicit prototype (a.k.a. the `[[Prototype]]` property).

Specified by:
  `getImplicitPrototype` in class `ObjectType`

### getConstructor

public FunctionType getConstructor()
Description copied from class: `ObjectType`
Gets this object's constructor.

Specified by:
  `getConstructor` in class `ObjectType`
Returns:
  this object's constructor or `null` if it is a native object (constructed natively v.s. by instantiation of a function)

### getReferenceName

public String getReferenceName()
Description copied from class: `ObjectType`
Gets the reference name for this object. This includes named types like constructors, prototypes, and enums. It notably does not include literal types like strings and booleans and structural types.

Specified by:
  `getReferenceName` in class `ObjectType`
Returns:
  the object's name or `null` if this is an anonymous object

### getDisplayName

public String getDisplayName()
Description copied from class: `JSType`
Returns a user meaningful label for the JSType instance. For example, Functions and Enums will return their declaration name (if they have one). Some types will not have a meaningful display name. Calls to hasDisplayName() will return true IFF getDisplayName() will return null or a zero length string.

Overrides:
  `getDisplayName` in class `ObjectType`
Returns:
  the display name of the type, or null if one is not available

### hasDisplayName

public boolean hasDisplayName()

Overrides:
  `hasDisplayName` in class `JSType`
Returns:
  true if the JSType has a user meaningful label.

### getPossibleToBooleanOutcomes

public BooleanLiteralSet getPossibleToBooleanOutcomes()
Description copied from class: `JSType`
Computes the set of possible outcomes of the `ToBoolean` predicate for this type. The `ToBoolean` predicate is defined by the ECMA-262 standard, 3rd edition. Its behavior for simple types can be summarized by the following table:

type | result
--- | ---
`undefined` | {false}
`null` | {false}
`boolean` | {true, false}
`number` | {true, false}
`string` | {true, false}
`Object` | {true}

Overrides:
  `getPossibleToBooleanOutcomes` in class `ObjectType`
Returns:
  the set of boolean literals for this type